!----------------------------------------------------------------------
!     Copyright (c) 2024 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_zonal_module_interpolate テストプログラム :: 補間関数のテスト
!
!履歴  2024/02/15  竹広真一    w_wave_module_interpolate_test.f90 を改造
!
program w_zonal_module_interpolate_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_zonal_module
  implicit none

  integer, parameter :: im=1, jm=32, nm=21

  real(8), allocatable             ::  w_data(:)
  real(8), dimension(0:im-1,1:jm)  ::  xy_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: data_sol
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call MessageNotify('M','w_zonal_module_interpolate_test', &
                         'w_zonal_module_interpolate interpolate(00) tests') 

  !---- Y_1^0 のテスト ----
  call w_Initial( nm, im, jm )
  allocate(w_data(nm+1))

  xy_data = sqrt(3.0D0)*sin(xy_Lat)                         ! Y_1^0
  data_sol = sqrt(3.0D0)*sin(ALat)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^0',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^0 のテスト ----
  xy_data = sqrt(5.0D0)*(3.0D0*sin(xy_Lat)**2-1.0D0)/2.0D0        ! Y_2^0
  data_sol = sqrt(5.0D0)*(3.0D0*sin(ALat)**2-1.0D0)/2.0D0
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^0',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_zonal_module_interpolate_test', &
                      'w_zonal_module_interpolate function tests succeeded') 

end program w_zonal_module_interpolate_test

